str2comm proto :DWORD, :DWORD
callStr proto :DWORD, :DWORD
RQ_CreateChatButton proto :DWORD, :DWORD, :DWORD
RQ_ModifyChatButton proto :DWORD, :DWORD, :DWORD
RQ_DeleteChatButton proto :DWORD

.data?

ContactInfo STRUCT
UIN	dw	?
Status	db	?
Invisible	db	?
DisplayedName db 256 dup(?)
First db 256 dup(?)
Last db 256 dup(?)
ContactInfo ENDS

callback dd ?
buffer db 1024 dup(?)
outBuffer db 1024 dup (?)

.code 
str2comm proc s:DWORD, len:DWORD
mov eax, len
mov dword ptr outBuffer,eax
invoke MemCopy,s,addr outBuffer+4,len
mov eax, offset outBuffer
ret
str2comm endp

callStr proc s:DWORD, len: DWORD
invoke str2comm,s,len
push eax
mov eax, callback
call eax
ret
callStr endp

RQ_CreateChatButton proc buttProc:DWORD, buttIcon:DWORD, buttHint:DWORD
LOCAL buff[64]: BYTE
mov byte ptr buff, PM_CMD
mov byte ptr buff+1, PC_ADDBUTTON
mov eax,buttProc
mov dword ptr buff+2, eax
mov eax,buttIcon
mov dword ptr buff+6, eax
invoke lstrlen,buttHint
mov dword ptr buff+10,eax
push eax
invoke lstrcpy, addr buff+14, buttHint
pop eax
add eax,14
invoke callStr, addr buff, eax
mov eax,[eax+4]
ret
RQ_CreateChatButton endp

RQ_ModifyChatButton proc buttAddr:DWORD, buttIcon:DWORD, buttHint:DWORD
LOCAL buff[64]: BYTE
mov byte ptr buff, PM_CMD
mov byte ptr buff+1, PC_MODIFY_BUTTON
mov eax,buttAddr
mov dword ptr buff+2, eax
mov eax,buttIcon
mov dword ptr buff+6, eax
invoke lstrlen,buttHint
mov dword ptr buff+10,eax
push eax
invoke lstrcpy, addr buff+14, buttHint
pop eax
add eax,14
invoke callStr, addr buff, eax
ret
RQ_ModifyChatButton endp

RQ_DeleteChatButton proc buttAddr:DWORD
LOCAL buff[64]: BYTE
mov byte ptr buff, PM_CMD
mov byte ptr buff+1, PC_DELBUTTON
mov eax, buttAddr
mov dword ptr buff+2, eax
invoke callStr, addr buff, 6
ret
RQ_DeleteChatButton endp
